#pragma once
class BSTNode {
public:
    int data;
    BSTNode* left, * right;
};

class BST
{    
public:
    BSTNode* root;  // korze drzewa

    BST();
    BST(int T[], int size);		//tworzy drzewo na podstawie tablicy
    ~BST() { remove(root); }; 			        //usuwa drzewo, zwalnia pami
    
    bool insert(BSTNode*& node, int wartosc);   //zwraca true - wez dodany, false-wze ju jest
    void remove(BSTNode* x);                    //usuwa poddrzewa o korzeniu w x
    BSTNode* search(int key);                   //zwraca wsk. na wze zawierajcy klucz key lub
                                               //NULL, jeli drzewo BST nie posiada takiego wza.
    int     maxKey();
    int     minKey();

    BSTNode* search(BSTNode* node, int key);
    int     minKey(BSTNode*);
    void    inorder(BSTNode* x);
    void    preorder(BSTNode* x);
    void    postorder(BSTNode* x);
    
    void print(BSTNode* );

};
